/******************************************************************************
 Basierend auf den Libraries von Peter Fleury!

 AD-Wandler.

 Liest 3 analoge Spannungswerte ein:
 - Temperatur
 - Absolutdruck
 - Differenzdruck

 Daraus wird der Volumesntrom berechnet. Hier nur B E I S P I E L H A F T ! ! !

 Temperatur wird an AD0 gemessen
 Absolutdruck wird an AD1 gemessen
 Differenzdruck wird an AD2 gemessen
 
*******************************************************************************/

#include<avr/io.h>

void lcd_putc();
void lcd_gotoxy();

/*****************************************
******************************************
**										**
**				BERECHNUNG				**
**										**
******************************************
******************************************/


uint8_t berechnen_VStrom (uint8_t temp, uint8_t absolutdruck, uint8_t differenzdruck) 
{

	uint8_t volumenstrom; //Ergebnisvariable Voluemstromberechnung

  	DDRB = 0xFF;      // port B output
 
  	// Activate ADC with Prescaler 16 --> 1Mhz/16 = 62.5kHz
  	ADCSRA = _BV(ADEN) | _BV(ADPS0) | _BV(ADPS1);
  
  	while(1) 
  		{  
			volumenstrom = (temp * absolutdruck) / differenzdruck;
			return volumenstrom;
  		}

}

/*****************************************
******************************************
**										**
**				FUNCTIONS				**
**										**
******************************************
******************************************/


/********************
*    Temperatur     *
********************/

uint8_t lese_Temperatur(void)
{
	ADMUX = 0xE0;
	ADCSRA = 0x85;  		//4MHz:32;

	uint8_t x=0;

    
    //Start conversion
    ADCSRA |= (1<<ADSC);
    
    // wait until converstion completed
    while (ADCSRA & _BV(ADSC) ) {}
    
    // get converted value
    x = ADCH;

    // output the higher 8 bits
	return x;
}

/********************
*   Absolutdruck    *
********************/
/*
uint8_t lese_Absolutdruck(void)
{
	uint8_t x=0, absolutdruck=0;

	// Select pin ADC1 using MUX
    ADMUX = 0x02;
    
    //Start conversion
    ADCSRA |= _BV(ADSC);
    
    // wait until converstion completed
    while (ADCSRA & _BV(ADSC) ) {}
    
    // get converted value
    x = ADCW;  
    
    // output the higher 8 bits
    absolutdruck = ~x>>2;

	return absolutdruck;

}*/

/********************
*  Differenzdruck   *
********************/

/*
uint8_t lese_Differenzdruck(void)
{
	uint8_t x=0, differenzdruck=0;

	// Select pin ADC2 using MUX
    ADMUX = 0x04;
    
    //Start conversion
    ADCSRA |= _BV(ADSC);
    
    // wait until converstion completed
    while (ADCSRA & _BV(ADSC) ) {}
    
    // get converted value
    x = ADCW;  
    
    // output the higher 8 bits
    differenzdruck = ~x>>2;

	return differenzdruck;

}*/

